package main

import (
	"log"

	. "ser1.net/legume"
	"ser1.net/legume/parse"
)

// Iterate over a channel of sources, parsing each and creating Issues from the
// contents. flagwords is used to add additional keywords to the built-in set
// of TODO, FIXME, etc.
//
// The sources are expected to be parsed out sourcecode
func findIssues(source <-chan SourceFile, errs <-chan error, flagwords []string, ff filterFunc) []Issue {
	var issues []Issue
	parse.SetKeywords(flagwords)
	var eok, fok bool = true, true
	var item SourceFile
	var err error
	// TODO multi-thread parsing
	for eok || fok {
		select {
		case err, eok = <-errs:
			if eok {
				log.Println(err)
			}
		case item, fok = <-source:
			if fok {
				for _, i := range parse.Parse(item) {
					if ff(i) {
						issues = append(issues, i)
					}
				}
			}
		}
	}
	for c := range source {
		for _, i := range parse.Parse(c) {
			if ff(i) {
				issues = append(issues, i)
			}
		}
	}
	return issues
}
