package csv

import (
	"io"
	"strconv"
	"strings"

	"encoding/csv"

	. "ser1.net/legume"
)

func ToString(is []Issue, out io.Writer) {
	c := csv.NewWriter(out)
	c.Write([]string{
		"path",
		"line",
		"priority",
		"created",
		"type",
		"change_type",
		"contexts",
		"projects",
		"tags",
		"description",
	})
	for _, i := range is {
		tags := make([]string, len(i.Tags))
		idx := 0
		for k, v := range i.Tags {
			tags[idx] = k + ":" + v
		}
		tag := strings.Join(tags, ",")
		date := ""
		if i.Date != nil {
			date = i.Date.Format("2017-01-02")
		}
		record := []string{
			i.Path,
			strconv.Itoa(i.Row),
			i.Priority,
			date,
			i.Type,
			Changes[i.Change],
			strings.Join(i.Contexts, ","),
			strings.Join(i.Projects, ","),
			tag,
			i.Description,
		}
		c.Write(record)
	}
	c.Flush()
}
