package json

import (
	"encoding/json"
	"io"
	"time"

	. "ser1.net/legume"
)

type JSONIssue struct {
	Path        string            `json:"path"`
	Row         int               `json:"row"`
	Description string            `json:"description"`
	Tags        map[string]string `json:"tags"`
	Contexts    []string          `json:"contexts"`
	Projects    []string          `json:"projects"`
	Date        *time.Time        `json:"created"`
	Priority    string            `json:"priority"`
	Change      int               `json:"changeType"`
}

func Convert(i Issue) JSONIssue {
	return JSONIssue{
		i.Path, i.Row, i.Description, i.Tags, i.Contexts, i.Projects, i.Date, i.Priority, i.Change,
	}
}

func ToString(is []Issue, out io.Writer) {
	js := make([]JSONIssue, len(is))
	for idx, i := range is {
		js[idx] = Convert(i)
	}
	bs, err := json.Marshal(js)
	if err != nil {
		panic(err)
	}
	out.Write(bs)
}
