package reader

import (
	. "ser1.net/legume"
	"bufio"
	"io"
)

type FSSourceFile struct {
	reader *bufio.Scanner
	typ    string
	path   string
	line   int
}

func New(r io.Reader, typ string, path string) FSSourceFile {
	return FSSourceFile{
		reader: bufio.NewScanner(r),
		typ:    typ,
		path:   path,
	}
}

func (f *FSSourceFile) Scan() bool {
	f.line++
	return f.reader.Scan()
}

func (f FSSourceFile) Line() int {
	return f.line
}

func (f FSSourceFile) Text() string {
	return f.reader.Text()
}

func (f FSSourceFile) Type() string {
	return f.typ
}

func (f FSSourceFile) Change() int {
	return ACTIVE
}

func (f FSSourceFile) Path() string {
	return f.path
}
