package stream

import (
	"reflect"
	"testing"

	dp "github.com/waigani/diffparser"
	. "ser1.net/legume"
)

func Test_diffSource_Read(t *testing.T) {
	type fields struct {
		file      *dp.DiffFile
		typ       string
		origLines []*dp.DiffLine
		newLines  []*dp.DiffLine
	}
	type args struct {
		p []byte
	}
	tests := []struct {
		name   string
		fields fields
		args   args
		want   bool
	}{
	// TODO: Add test cases. Test_diffSource_Read
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			d := diffSource{
				file: tt.fields.file,
				typ:  tt.fields.typ,
			}
			got := d.Scan()
			if got != tt.want {
				t.Errorf("diffSource.Read() %s = %v, want %v", tt.name, got, tt.want)
			}
		})
	}
}

func Test_diffSource_LineOffset(t *testing.T) {
	type fields struct {
		file *dp.DiffFile
		typ  string
	}
	tests := []struct {
		name   string
		fields fields
		want   int
	}{
	// TODO: Add test cases. Test_diffSource_LineOffset
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			f := diffSource{
				file: tt.fields.file,
				typ:  tt.fields.typ,
			}
			if got := f.Line(); got != tt.want {
				t.Errorf("diffSource.LineOffset() %s = %v, want %v", tt.name, got, tt.want)
			}
		})
	}
}

func Test_diffSource_Type(t *testing.T) {
	type fields struct {
		file      *dp.DiffFile
		typ       string
		origLines []*dp.DiffLine
		newLines  []*dp.DiffLine
	}
	tests := []struct {
		name   string
		fields fields
		want   string
	}{
	// TODO: Add test cases. Test_diffSource_Type
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			f := diffSource{
				file: tt.fields.file,
				typ:  tt.fields.typ,
			}
			if got := f.Type(); got != tt.want {
				t.Errorf("diffSource.Type() %s = %v, want %v", tt.name, got, tt.want)
			}
		})
	}
}

func Test_diffSource_Path(t *testing.T) {
	type fields struct {
		file *dp.DiffFile
		typ  string
	}
	tests := []struct {
		name   string
		fields fields
		want   string
	}{
	// TODO: Add test cases. Test_diffSource_Path
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			f := diffSource{
				file: tt.fields.file,
				typ:  tt.fields.typ,
			}
			if got := f.Path(); got != tt.want {
				t.Errorf("diffSource.Path() %s = %v, want %v", tt.name, got, tt.want)
			}
		})
	}
}

func TestMakeSource(t *testing.T) {
	type args struct {
		aliases map[string]string
		inEx    func(s string) bool
	}
	tests := []struct {
		name  string
		args  args
		want  <-chan SourceFile
		want1 <-chan error
	}{
	// TODO: Add test cases. TestMakeSource
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			got, got1 := MakeSource(tt.args.aliases, tt.args.inEx)
			if !reflect.DeepEqual(got, tt.want) {
				t.Errorf("MakeSource() %s got = %v, want %v", tt.name, got, tt.want)
			}
			if !reflect.DeepEqual(got1, tt.want1) {
				t.Errorf("MakeSource() %s got1 = %v, want %v", tt.name, got1, tt.want1)
			}
		})
	}
}

func Test_processIO(t *testing.T) {
	type args struct {
		aliases map[string]string
		inEx    func(s string) bool
		sfs     chan<- SourceFile
		ers     chan<- error
	}
	tests := []struct {
		name string
		args args
	}{
	// TODO: Add test cases. Test_processIO
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			processIO(tt.args.aliases, tt.args.inEx, tt.args.sfs, tt.args.ers)
		})
	}
}
