package vim

import (
	"fmt"
	"io"
	"sort"
	"strings"

	. "ser1.net/legume"
)

func ToString(is []Issue, out io.Writer) {
	// TODO sort by priority
	sort.Slice(is, func(i, j int) bool {
		n := strings.Compare(is[i].Path, is[j].Path)
		if n == 0 {
			return is[i].Row < is[j].Row
		}
		return n < 0
	})
	for _, i := range is {
		p := i.Priority
		if p == "" {
			p = "_"
		}
		desc := i.Description
		lines := strings.Split(desc, "\n")
		if len(lines) > 1 {
			desc = strings.Join(lines, " ")
		}
		fmt.Fprintf(out, "%s:%d:0 %s %s\n", i.Path, i.Row, i.Type, desc)
	}
}
